#ifndef RESOURCEMANAGER_INCLUDED
 #define RESOURCEMANAGER_INCLUDED

#include "model.h"
#include <vector>
#include <allegro.h>

class ResourceManager
{
	private:
		std::vector <int> textureIds;
		std::vector <Model> models;
		std::vector <SAMPLE *> samples;
	public:
		enum Texture {
			PlayerSkin = 1,
			PlayerDeadSkin,
			BrickTexture,
			EarthTexture,
			StoneTexture,
			GenericTexture,
			StalkTexture,
			BeanTexture,
			BackgroundTexture,
			TreasureTexture,
			TitleTexture,
			GiantTexture,
			MaxTexture
		};
		enum ModelType {
			Empty = 1,
			Stalk1,
			Stalk2,
			Stalk3,
			Jack,
			JackWalking1,
			JackWalking2,
			JackWalking3,
			JackWalking4,
			JackClimbing1,
			JackClimbing2,
			JackDead,
			Spikes,
			Door1,
			Door2,
			Giant,
			MaxModel
		};
		
		enum SampleType {
			Step1 = 1,
			Step2,
			Stomp,
			Growing,
			Throw,
			Death,
			MaxSample
		};
	
		
		ResourceManager();
		void loadAll();
		
		int getTexture(Texture which)
		{
			return textureIds[(int) which];
		}
		
		SAMPLE * getSample(SampleType which) {
			return samples[which];
		}
		
		const Model & getModel(ModelType which)
		{
			return models[which];
		}

};

extern ResourceManager resourceManager;

#endif // RESOURCEMANAGER_INCLUDED

